--[[
	##AddOn	: CooldownIcons R(evamped)
	##Subfile	: options.lua
	##Author  : Hati ( xhatix @ curseforge.com )
--]]
local CIR = CooldownIconsR
local db = CIR.db
CIR.Options = {
	type='group',
	name="CooldownIcons R(evamped)",
	handler = CIR,
	args = {
		global_settings={
			type = 'group',
			childGroups='tab',
			name = "Global Settings",
			order = 1,
			args={},
		},
		icon_settings={
			type='group',
			name='Icon Settings',
			childGroups='select',order=2,
			width='double',
			args={},
		},
		help={
			type='group',
			name='Help',
			order=3,
			args={},
		},
	}
}

--frame for time format 4 borders
StaticPopupDialogs["CIR_REQUEST_TIMEFORMAT4"] = {
	text = "[%s] Please enter the time value, CiR should start to display miliseconds.",
	button1 = YES,
	button2 = NO,
	OnAccept = function(self)
	end,
	OnCancel = function(self)
	end,
	timeout = 0,
	whileDead = 1,
	exclusive = 1,
	showAlert = 1,
	hideOnEscape = 1,
	hasEditBox = 1,
	maxLetters = 3,
	OnShow = function(self)
		self.button1:Disable()
		if self.data=="GLOBAL" then
			self.editBox:SetText(CIR.db.char.gIcon.iTimeFormat4_Border or 10)
		else
			self.editBox:SetText(self.data.timeFormat4 or 10)
		end
		self.editBox:SetFocus()
		
	end,
	EditBoxOnEnterPressed = function(self)
        local popup = self:GetParent()
		if ( popup.button1:IsEnabled() ) then
			local v = tonumber(self:GetText())
            if popup.data=="GLOBAL" then
				CIR.db.char.gIcon.timeFormat4=v
				for obj,t in pairs(CIR.icons) do
					t.timeFormat4 = v
					CIR.db.char.icondb[obj].iTimeFormat4_Border = v
				end
			else
				popup.data.timeFormat4=v
                CIR.db.char.icondb[popup.data.name].iTimeFormat4_Border = v
			end
			popup:Hide()
		end
	end,
	EditBoxOnTextChanged = function (self)
		local parent = self:GetParent();
		if ( tonumber(self:GetText()) ) then
			parent.button1:Enable();
		else
			parent.button1:Disable();
		end
	end,
}

function CIR:InitOptions()
	LibStub('AceConfig-3.0'):RegisterOptionsTable( 'CooldownIcons_Revamped', self.Options)
	local ACD = LibStub( 'AceConfigDialog-3.0')
	ACD:SetDefaultSize(self.name, 1000,800)
	self.Options.args.global_settings.args = self.get_global_settings()	
	self.Options.args.icon_settings.args = self.get_icon_settings()
	self.Options.args.help.args = self.get_help_table()
	--for k,v in pairs(CIR.db.char.icondb) do)
	--end
	--[[self.OptionsPanel = ACD:AddToBlizOptions(self.name, "CooldownIcons R", nil, "global_layout")]]
end

function CIR:ReconstructIcons()
	for k,v in pairs(CIR.db.char.icondb) do
		--print("["..k.."] = "..tostring(v))
		CIR:add_icon_settings(k,v.iDisplayName)
		if v.iEnabled then
			CIR:CreateIcon(k)
			CIR:ProcessScriptForIcon(v.script,CIR.icons[k])
		end
	end
end
